#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>

#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdlib.h>

#include <string>
#include <vector>
using namespace std;

#pragma comment( lib, "../bin/pdf2image.lib" )

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter(const char *lpszPDFFileName, const char *lpszOutputName,
								  const char *lpszUserPassword, const char *lpszOwnPassword,
								  int xresolution, int yresolution, int bitcount, 
								  int compression, int quality, BOOL grayscale, 
								  BOOL multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverterEx(const char *lpszPDFFileName, const char *lpszOutputName,
									const char *lpszUserPassword, const char *lpszOwnPassword, int nIsWidthAndHeight,
									int xResORWidth, int yResORHeight, int bitcount, 
									int compression, int quality, int grayscale, 
									int multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2(const char *lpszPDFFileName, const char *lpszOutputName,
								   const char *lpszUserPassword, const char *lpszOwnPassword,
								   int xresolution, int yresolution, int bitcount, 
								   int compression, int quality, BOOL grayscale, 
								   BOOL multipage,  int firstPage,int lastPage);

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter3(const char *lpszPDFFile, const char *lpszOutFile,
									const char *lpszUserPassword, const char *lpszOwnPassword,
									int nIsWidthAndHeight, int xResORWidth, int yResORHeight,
									int bitcount, int compression, int quality, int grayscale, 
									int multipage,  int firstPage, int lastPage);

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2Ex(const char *lpszPDFFileName, const char *lpszOutputName,
									 const char *lpszUserPassword, const char *lpszOwnPassword, int nIsWidthAndHeight,
									 int xResORWidth, int yResORHeight, int bitcount, 
									 int compression, int quality, int grayscale, 
									 int multipage,  int firstPage,int lastPage);

extern "C" __declspec(dllexport)
int __stdcall PDFToImageConverterByMode(int mode,
										const char *lpszPDFFileName, const char *lpszOutputName,
										const char *lpszUserPassword, const char *lpszOwnPassword, 
										int nIsWidthAndHeight, int xResORWidth, int yResORHeight, 
										int bitcount, int compression, int quality, int grayscale, 
										int multipage, int firstPage, int lastPage, const char *lpOtherOptions
										);

extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetParameters(const char *lpparms);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageGetPageCount(const char *lpszPDFFileName);
extern "C" __declspec(dllexport)
HBITMAP __stdcall PDFToImageDrawToHDC(const char *lpszPDFFileName, HDC hDC, const char *lpszUserPassword, 
									  const char *lpszOwnPassword, int xresolution, int yresolution, 
									  int m_iBitCount, BOOL m_bGrayscale, int m_iPageIndex);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageBox(const char *lpinputPDFFile, int page, double *extent);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageWidth(const char *lpinputPDFFile, int page);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageHeight(const char *lpinputPDFFile, int page);
typedef int (__stdcall *PDFToImageProgressCBFunc)(void *, UINT Msg, WPARAM wParam, LPARAM lParam);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetProgressCBFunc(PDFToImageProgressCBFunc newFunc);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetFileNameSuffix(const char *ptrFileNameSuffix);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetCode(const char *lpRegcode);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageEnableErrorDiffusion(BOOL bEnable);


extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetPageCount(char *inputTIFFFile);
extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetColors(char *inputTIFFFile, int pageno);
extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetCompression(char *inputTIFFFile, int pageno);

#define COMPRESSION_NONE                                1 /* dump mode */
#define COMPRESSION_CCITTRLE                            2 /* CCITT modified Huffman RLE */
#define COMPRESSION_CCITTFAX3                           3 /* CCITT Group 3 fax encoding */
#define COMPRESSION_CCITTFAX4                           4 /* CCITT Group 4 fax encoding */
#define COMPRESSION_LZW                                 5 /* Lempel-Ziv  & Welch */
#define COMPRESSION_JPEG                                7 /* %JPEG DCT compression */
#define COMPRESSION_PACKBITS                        32773 /* Macintosh RLE */
#define	COMPRESSION_BMP_RLE                      70000000 /* RunLength BMP compression */
#define	COMPRESSION_CLASSF204X98_G3              88888886
#define	COMPRESSION_CLASSF204X196_G3             88888887
#define	COMPRESSION_CLASSF                       88888888
#define	COMPRESSION_CLASSF196                    88888889
#define	COMPRESSION_CLASSF204X98_G4              88888888
#define	COMPRESSION_CLASSF204X196_G4             88888889
#define COMPRESSION_CLASSF_204X98_2048X1401_G4   88888890
#define	COMPRESSION_CLASSF_204X196_2048X2802_G4  88888891
#define	COMPRESSION_CLASSF_204X98_1620X1146_G4   88888892
#define COMPRESSION_CLASSF_204X98_1728X1143_G4   88888893
#define COMPRESSION_CLASSF_204X196_1728X2286_G4  88888894
#define COMPRESSION_CLASSF_204X98_1728X1074_G4   88888895
#define COMPRESSION_CLASSF_204X98_2200X1700_G4   88888896
#define COMPRESSION_CLASSF_204X98_1728X2200_G4   88888897
#define COMPRESSION_CLASSF_204X196_1728X2200_G4  88888898
#define COMPRESSION_CLASSF_204X196_1728X1100_G4  88888899
#define COMPRESSION_CLASSF_204X98__1728X1100_G4  88888900

int __stdcall PageProgressCBFunc(void *ptrPDFName, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	printf("PDFName=%s,Msg=%d,CurrentPage=%d,LastPage=%d\n",(char*)ptrPDFName,Msg,wParam,lParam);
	return 1;
}

void main(int argc, char *argv[])
{
	if(argc != 3)
	{
		printf("\"%s\" test.pdf out.jpg\n");
		printf("\"%s\" test.pdf out.png\n");
		printf("\"%s\" test.pdf out.tif\n");
		printf("\"%s\" test.pdf out.bmp\n");
		return;
	}

	char *lpInFile = argv[1];
	char *lpOutFile = argv[2];

	char szOutFileName[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	char fname2[_MAX_PATH];
	PDFToImageSetCode("XXXXXXXXXXXXXXXXXXXXXXX");
	PDFToImageSetFileNameSuffix(".%03u");
	PDFToImageSetProgressCBFunc(PageProgressCBFunc);

	{
		_splitpath(lpOutFile, drive, dir, fname, ext);
		strcpy(fname2, fname);
		strcat(fname2, "_PDFToImageConverter");
		_makepath(szOutFileName, drive, dir, fname2, ext);
		int time1 = GetTickCount();
		int nResult = PDFToImageConverter(lpInFile, szOutFileName, NULL, NULL, 200, 200, 24, COMPRESSION_PACKBITS, 100, 0, FALSE, -1, -1);
		int time2 = GetTickCount();
		printf("%s return %d, spent %.2f seconds\n", fname2, nResult, (time2-time1)/1000.0);
	}
	{
		_splitpath(lpOutFile, drive, dir, fname, ext);
		strcpy(fname2, fname);
		strcat(fname2, "_PDFToImageConverter2");
		_makepath(szOutFileName, drive, dir, fname2, ext);
		int time1 = GetTickCount();
		int nResult = PDFToImageConverter2(lpInFile, szOutFileName, NULL, NULL, 200, 200, 24, COMPRESSION_PACKBITS, 100, 0, FALSE, -1, -1);
		int time2 = GetTickCount();
		printf("%s return %d, spent %.2f seconds\n", fname2, nResult, (time2-time1)/1000.0);
	}
	{
		int nMode = 0;
		_splitpath(lpOutFile, drive, dir, fname, ext);
		strcpy(fname2, fname);
		sprintf(fname2+strlen(fname2), "_PDFToImageConverterByMode_%d", nMode);
		_makepath(szOutFileName, drive, dir, fname2, ext);
		int time1 = GetTickCount();
		int nResult = PDFToImageConverterByMode(nMode, lpInFile, szOutFileName, NULL, NULL, 0, 200, 200, 24, COMPRESSION_PACKBITS, 100, 0, FALSE, -1, -1, NULL);
		int time2 = GetTickCount();
		printf("%s return %d, spent %.2f seconds\n", fname2, nResult, (time2-time1)/1000.0);
	}
	{
		int nMode = 1;
		_splitpath(lpOutFile, drive, dir, fname, ext);
		strcpy(fname2, fname);
		sprintf(fname2+strlen(fname2), "_PDFToImageConverterByMode_%d", nMode);
		_makepath(szOutFileName, drive, dir, fname2, ext);
		int time1 = GetTickCount();
		int nResult = PDFToImageConverterByMode(nMode, lpInFile, szOutFileName, NULL, NULL, 0, 200, 200, 24, COMPRESSION_PACKBITS, 100, 0, FALSE, -1, -1, NULL);
		int time2 = GetTickCount();
		printf("%s return %d, spent %.2f seconds\n", fname2, nResult, (time2-time1)/1000.0);
	}
	{
		int nMode = 3;
		_splitpath(lpOutFile, drive, dir, fname, ext);
		strcpy(fname2, fname);
		sprintf(fname2+strlen(fname2), "_PDFToImageConverterByMode_%d", nMode);
		_makepath(szOutFileName, drive, dir, fname2, ext);
		int time1 = GetTickCount();
		int nResult = PDFToImageConverterByMode(nMode, lpInFile, szOutFileName, NULL, NULL, 0, 200, 200, 24, COMPRESSION_PACKBITS, 100, 0, FALSE, -1, -1, NULL);
		int time2 = GetTickCount();
		printf("%s return %d, spent %.2f seconds\n", fname2, nResult, (time2-time1)/1000.0);
	}
}

