#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>

#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdlib.h>

#include <string>
#include <vector>
using namespace std;

#pragma comment( lib, "../bin/pdf2image.lib" )

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter(const char *szPDFFileName, const char *szOutputName,
								  const char *szUserPassword, const char *szOwnPassword,
								  int xresolution, int yresolution, int bitcount, 
								  int compression, int quality, BOOL grayscale, 
								  BOOL multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverterEx(const char *szPDFFileName, const char *szOutputName,
									const char *szUserPassword, const char *szOwnPassword, int nIsWidthAndHeight,
									int xResORWidth, int yResORHeight, int bitcount, 
									int compression, int quality, int grayscale, 
									int multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2(const char *szPDFFileName, const char *szOutputName,
								   const char *szUserPassword, const char *szOwnPassword,
								   int xresolution, int yresolution, int bitcount, 
								   int compression, int quality, BOOL grayscale, 
								   BOOL multipage,  int firstPage,int lastPage);

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter3(const char *lpszPDFFile, const char *lpszOutFile,
									const char *lpszUserPassword, const char *lpszOwnPassword,
									int nIsWidthAndHeight, int xResORWidth, int yResORHeight,
									int bitcount, int compression, int quality, int grayscale, 
									int multipage,  int firstPage, int lastPage);

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2Ex(const char *szPDFFileName, const char *szOutputName,
									 const char *szUserPassword, const char *szOwnPassword, int nIsWidthAndHeight,
									 int xResORWidth, int yResORHeight, int bitcount, 
									 int compression, int quality, int grayscale, 
									 int multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetParameters(const char *parms);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageGetPageCount(const char *szPDFFileName);
extern "C" __declspec(dllexport)
HBITMAP __stdcall PDFToImageDrawToHDC(const char *szPDFFileName, HDC hDC, const char *szUserPassword, 
									  const char *szOwnPassword, int xresolution, int yresolution, 
									  int m_iBitCount, BOOL m_bGrayscale, int m_iPageIndex);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageBox(const char *inputPDFFile, int page, double *extent);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageWidth(const char *inputPDFFile, int page);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageHeight(const char *inputPDFFile, int page);
typedef int (__stdcall *PDFToImageProgressCBFunc)(void *, UINT Msg, WPARAM wParam, LPARAM lParam);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetProgressCBFunc(PDFToImageProgressCBFunc newFunc);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetFileNameSuffix(const char *ptrFileNameSuffix);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetCode(const char *lpRegcode);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageEnableErrorDiffusion(BOOL bEnable);


extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetPageCount(char *inputTIFFFile);
extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetColors(char *inputTIFFFile, int pageno);
extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetCompression(char *inputTIFFFile, int pageno);

#define	COMPRESSION_NONE                         1            /* dump mode */
#define	COMPRESSION_CCITTRLE                     2            /* CCITT modified Huffman RLE */
#define	COMPRESSION_CCITTFAX3                    3            /* CCITT Group 3 fax encoding */
#define	COMPRESSION_CCITTFAX4                    4            /* CCITT Group 4 fax encoding */
#define	COMPRESSION_LZW                          5            /* Lempel-Ziv  & Welch */
#define	COMPRESSION_JPEG                         7	          /* %JPEG DCT compression */
#define	COMPRESSION_PACKBITS                     32773        /* Macintosh RLE */
#define	COMPRESSION_CLASSF                       88888888
#define	COMPRESSION_CLASSF196                    88888889

#define	COMPRESSION_CLASSF204X98_G3              88888886
#define	COMPRESSION_CLASSF204X196_G3             88888887
#define	COMPRESSION_CLASSF204X98_G4              88888888
#define	COMPRESSION_CLASSF204X196_G4             88888889
#define COMPRESSION_CLASSF_204X98_2048X1401_G4   88888890
#define	COMPRESSION_CLASSF_204X196_2048X2802_G4  88888891
#define	COMPRESSION_CLASSF_204X98_1620X1146_G4   88888892
#define COMPRESSION_CLASSF_204X98_1728X1143_G4   88888893
#define COMPRESSION_CLASSF_204X196_1728X2286_G4  88888894
#define COMPRESSION_CLASSF_204X98_1728X1074_G4   88888895
#define COMPRESSION_CLASSF_204X98_2200X1700_G4   88888896
#define COMPRESSION_CLASSF_204X98_1728X2200_G4   88888897
#define COMPRESSION_CLASSF_204X196_1728X2200_G4  88888898
#define COMPRESSION_CLASSF_204X196_1728X1100_G4  88888899
#define COMPRESSION_CLASSF_204X98_1728X1100_G4   88888900

#define COMPRESSION_CLASSF_204X196_1728X1143_G4  88888901
#define COMPRESSION_CLASSF_204X98_1728X2286_G4   88888902
#define COMPRESSION_CLASSF_204X98_2048X2802_G4   88888903
#define COMPRESSION_CLASSF_204X196_2048X1401_G4  88888904

///////////////////////////////////////////
//
//  Set options into a TIFF file
//
//  Parameters
//
//  char *inputTIFFFile:  input TIFF file
//  int pageno:  specify page index
//  int colors:  specify colors, it can be 1, 4, 8, 24
//  int compression: 
//#define	    COMPRESSION_NONE		1	/* dump mode */
//#define	    COMPRESSION_CCITTRLE	2	/* CCITT modified Huffman RLE */
//#define	    COMPRESSION_CCITTFAX3	3	/* CCITT Group 3 fax encoding */
//#define     COMPRESSION_CCITT_T4        3       /* CCITT T.4 (TIFF 6 name) */
//#define	    COMPRESSION_CCITTFAX4	4	/* CCITT Group 4 fax encoding */
//#define     COMPRESSION_CCITT_T6        4       /* CCITT T.6 (TIFF 6 name) */
//#define	    COMPRESSION_LZW		5       /* Lempel-Ziv  & Welch */
//#define	    COMPRESSION_OJPEG		6	/* !6.0 JPEG */
//#define	    COMPRESSION_JPEG		7	/* %JPEG DCT compression */
//
//
///////////////////////////////////////////
extern "C" __declspec(dllexport)
int __stdcall TIFFImageSetOptions(char *inputTIFFFile, int pageno, int colors, int compression);

typedef struct PDF2IMAGETHREADINFOtag{
	char szPDFName[MAX_PATH];
	int  dwThreadID;
	int  iResult;
}PDF2IMAGETHREADINFO,*LPPDF2IMAGETHREADINFO;
static DWORD WINAPI LaunchPDF2ImageThread(LPVOID pParam)
{
	LPPDF2IMAGETHREADINFO lpPDF2ImgInfo = (LPPDF2IMAGETHREADINFO)pParam;
	int iThreadID = GetCurrentThreadId();
	char szOutName[MAX_PATH];
	char szFileExt[MAX_PATH];
	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[MAX_PATH],ext[_MAX_EXT];

	{
		sprintf(szFileExt,"_%d",iThreadID);
		_splitpath(lpPDF2ImgInfo->szPDFName, drive, dir, fname, ext );
		strcat(fname, "204X98");
		strcat(fname, szFileExt);
		_makepath(szOutName, drive, dir, fname, ".tif");
		
		int nResult = PDFToImageConverter(lpPDF2ImgInfo->szPDFName, szOutName, NULL,
			NULL, 300, 300, 1, COMPRESSION_CLASSF_204X98_2048X1401_G4, 100, FALSE, TRUE, -1, -1);
		printf("ThreadID = %d, OutName = %s, Result = %d\n",iThreadID, szOutName, nResult);
	}
	{
		sprintf(szFileExt,"_%d",iThreadID);
		_splitpath(lpPDF2ImgInfo->szPDFName, drive, dir, fname, ext );
		strcat(fname, "204X196");
		strcat(fname, szFileExt);
		_makepath(szOutName, drive, dir, fname, ".tif");
		
//		int nResult = PDFToImageConverter(lpPDF2ImgInfo->szPDFName, szOutName, NULL,
//			NULL, 300, 300, 1, COMPRESSION_CLASSF_204X196_2048X2802_G4, 100, FALSE, TRUE, -1, -1);
		int nResult = PDFToImageConverter(lpPDF2ImgInfo->szPDFName, szOutName, NULL,
			NULL, 300, 300, 1, COMPRESSION_CLASSF_204X98_1728X2200_G4, 100, FALSE, TRUE, -1, -1);
		printf("ThreadID = %d, OutName = %s, Result = %d\n",iThreadID, szOutName, nResult);
	}
	return 0;
}
void TestForMultiThread(char *szPDFName)
{
	PDFToImageSetProgressCBFunc(NULL);

#define MAX_THREADS 10
	HANDLE aryHandles[MAX_THREADS] = {0};
	for(int i = 0; i < MAX_THREADS; i++)
	{
		LPPDF2IMAGETHREADINFO lpPDF2ImgInfo = new PDF2IMAGETHREADINFO;
		strcpy(lpPDF2ImgInfo->szPDFName,szPDFName);
		
		DWORD dwThreadId;
		aryHandles[i] = CreateThread(NULL,0,LaunchPDF2ImageThread,lpPDF2ImgInfo,0,&dwThreadId);
	}
	WaitForMultipleObjects(MAX_THREADS, aryHandles, TRUE, INFINITE);
}

void main(int argc, char *argv[])
{
	if(argc != 2)
	{
		printf("\"%s\" test.pdf\n", argv[0]);
		return;
	}
	PDFToImageSetCode("XXXXXXXXXXXXXXXXXXXXXXX");
	TestForMultiThread(argv[1]);
	printf("Press any key to continue...\n");
	getchar();
}