#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>

#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdlib.h>

#include <string>
#include <vector>
using namespace std;

#pragma comment( lib, "../bin/pdf2image.lib" )

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter(const char *szPDFFileName, const char *szOutputName,
								  const char *szUserPassword, const char *szOwnPassword,
								  int xresolution, int yresolution, int bitcount, 
								  int compression, int quality, BOOL grayscale, 
								  BOOL multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverterEx(const char *szPDFFileName, const char *szOutputName,
									const char *szUserPassword, const char *szOwnPassword, int nIsWidthAndHeight,
									int xResORWidth, int yResORHeight, int bitcount, 
									int compression, int quality, int grayscale, 
									int multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2(const char *szPDFFileName, const char *szOutputName,
								   const char *szUserPassword, const char *szOwnPassword,
								   int xresolution, int yresolution, int bitcount, 
								   int compression, int quality, BOOL grayscale, 
								   BOOL multipage,  int firstPage,int lastPage);

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter3(const char *lpszPDFFile, const char *lpszOutFile,
									const char *lpszUserPassword, const char *lpszOwnPassword,
									int nIsWidthAndHeight, int xResORWidth, int yResORHeight,
									int bitcount, int compression, int quality, int grayscale, 
									int multipage,  int firstPage, int lastPage);

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2Ex(const char *szPDFFileName, const char *szOutputName,
									 const char *szUserPassword, const char *szOwnPassword, int nIsWidthAndHeight,
									 int xResORWidth, int yResORHeight, int bitcount, 
									 int compression, int quality, int grayscale, 
									 int multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetParameters(const char *parms);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageGetPageCount(const char *szPDFFileName);
extern "C" __declspec(dllexport)
HBITMAP __stdcall PDFToImageDrawToHDC(const char *szPDFFileName, HDC hDC, const char *szUserPassword, 
									  const char *szOwnPassword, int xresolution, int yresolution, 
									  int m_iBitCount, BOOL m_bGrayscale, int m_iPageIndex);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageBox(const char *inputPDFFile, int page, double *extent);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageWidth(const char *inputPDFFile, int page);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageHeight(const char *inputPDFFile, int page);
typedef int (__stdcall *PDFToImageProgressCBFunc)(void *, UINT Msg, WPARAM wParam, LPARAM lParam);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetProgressCBFunc(PDFToImageProgressCBFunc newFunc);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetFileNameSuffix(const char *ptrFileNameSuffix);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetCode(const char *lpRegcode);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageEnableErrorDiffusion(BOOL bEnable);


extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetPageCount(char *inputTIFFFile);
extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetColors(char *inputTIFFFile, int pageno);
extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetCompression(char *inputTIFFFile, int pageno);

#define COMPRESSION_NONE                                1 /* dump mode */
#define COMPRESSION_CCITTRLE                            2 /* CCITT modified Huffman RLE */
#define COMPRESSION_CCITTFAX3                           3 /* CCITT Group 3 fax encoding */
#define COMPRESSION_CCITTFAX4                           4 /* CCITT Group 4 fax encoding */
#define COMPRESSION_LZW                                 5 /* Lempel-Ziv  & Welch */
#define COMPRESSION_JPEG                                7 /* %JPEG DCT compression */
#define COMPRESSION_PACKBITS                        32773 /* Macintosh RLE */
#define	COMPRESSION_BMP_RLE                      70000000 /* RunLength BMP compression */
#define	COMPRESSION_CLASSF204X98_G3              88888886
#define	COMPRESSION_CLASSF204X196_G3             88888887
#define	COMPRESSION_CLASSF                       88888888
#define	COMPRESSION_CLASSF196                    88888889
#define	COMPRESSION_CLASSF204X98_G4              88888888
#define	COMPRESSION_CLASSF204X196_G4             88888889
#define COMPRESSION_CLASSF_204X98_2048X1401_G4   88888890
#define	COMPRESSION_CLASSF_204X196_2048X2802_G4  88888891
#define	COMPRESSION_CLASSF_204X98_1620X1146_G4   88888892
#define COMPRESSION_CLASSF_204X98_1728X1143_G4   88888893
#define COMPRESSION_CLASSF_204X196_1728X2286_G4  88888894
#define COMPRESSION_CLASSF_204X98_1728X1074_G4   88888895
#define COMPRESSION_CLASSF_204X98_2200X1700_G4   88888896
#define COMPRESSION_CLASSF_204X98_1728X2200_G4   88888897
#define COMPRESSION_CLASSF_204X196_1728X2200_G4  88888898
#define COMPRESSION_CLASSF_204X196_1728X1100_G4  88888899
#define COMPRESSION_CLASSF_204X98__1728X1100_G4  88888900


void main(int argc, char *argv[])
{
	if(argc != 3)
		return;
	PDFToImageSetCode("XXXXXXXXXXXXXXXXXXXXXXX");
	int time1 = GetTickCount();
	//int nResult = PDFToImageConverter(argv[1], argv[2], NULL, NULL, 200, 200, 1, COMPRESSION_CCITTFAX4, 100, 0, TRUE, -1, -1);
	int nResult = PDFToImageConverter(argv[1], argv[2], NULL, NULL, 200, 200, 24, COMPRESSION_NONE, 100, 0, TRUE, -1, -1);
	int time2 = GetTickCount();
	printf("[Message] xdpi = %d, ydpi = %d\n", 200, 200);
	printf("[Message] Used time = %d (%.2fs)\n", time2-time1, (time2-time1)/1000.0);
}

